c	TIC -- John Coonrod's version of the CICADA TIC routines	!01/15/85
C
c	This package provides three levels of TIC routines:
c	1. Normal	at_xxxx
c	2. Backspace	at_bxxxx
c	3. Limit-check	at_lxxxx
c	4. Limit/Back	at_blxxxx
C
	subroutine at__error(string,kind)	!Internal error routine	!04/03/85
	character*(*) string,kind
	call at_reset
	type *,'Sorry, ',string(1:jc_trim(string)),' is not a valid ',
     >		kind,' input.'
	end
	subroutine at_int(prompt,ival)		!integer value		!11/09/84
	character prompt*(*),string*12,back*(*)
	character istrin*12
	logical needb,lims
	needb=.false.
	lims=.false.
	go to 100
c
	entry at_bint(prompt,ival,back)
	needb=.true.
	lims=.false.
	back=' '
	go to 100
c
	entry at_lint(prompt,ival,ilo,ihi)
	needb=.false.
	lims=.true.
	go to 100
c
	entry at_blint(prompt,ival,ilo,ihi,back)
	needb=.true.
	lims=.true.
	back=' '
 100	continue
	call jc__cint(ival,istrin)	!Convert integer to string
	ios=1
	do while(ios.ne.0)		!Repeat until a good value appears
	  string=istrin
	  if(needb) then
	    call at_bchar(prompt,string,back)
	    if(back.ne.' ') return
	  else
	    call at_char(prompt,string)
	  endif
	  read(string,'(bn,i12)',iostat=ios) i
	  if(ios.ne.0) then
	    call at__error(string,'Integer')
	  elseif(lims) then
	    if(i.lt.ilo .or. i.gt.ihi) then
	      type *,'Sorry, integer out of range',ilo,ihi
	      ios=-1
	    endif
	  endif
	enddo
	ival=i
	end
	subroutine at_hex(prompt,ival)		!hex value		!11/09/84
	character prompt*(*),string*8,back*(*)
	character istrin*8
	logical needb,lims
	needb=.false.
	lims=.false.
	go to 100
c
	entry at_bhex(prompt,ival,back)
	needb=.true.
	lims=.false.
	back=' '
	go to 100
c
	entry at_lhex(prompt,ival,ilo,ihi)
	needb=.false.
	lims=.true.
 100	continue
	write(istrin,'(z8)')ival	!Convert to hex
	ios=1
	do while(ios.ne.0)
	  string=istrin
	  if(needb) then
	    call at_bchar(prompt,string,back)
	    if(back.ne.' ') return
	  else
	    call at_char(prompt,string)
	  endif
	  read(string,'(bn,z8)',iostat=ios) i
	  if(ios.ne.0) then
	    call at__error(string,'Hex')
	  elseif(lims) then
	    if(i.lt.ilo .or. i.gt.ihi) then
	      type *,'Sorry, hex value out of range',ilo,ihi
	      ios=-1
	    endif
	  endif
	enddo
	ival=i
	end
	subroutine at_real(prompt,val)		!real value		!11/09/84
	character prompt*(*),string*20,back*(*)
	character istrin*20
	logical needb,lims,spchk
	external setr,chkr
	needb=.false.
	lims=.false.
	spchk=.false.
	go to 100
c
	entry at_breal(prompt,val,back)
	needb=.true.
	lims=.false.
	back=' '
	spchk=.false.
	go to 100
c
	entry at_lreal(prompt,val,rlo,rhi)
	needb=.false.
	lims=.true.
	spchk=.false.
	go to 100
c
	entry at_blreal(prompt,val,rlo,rhi,back)
	needb=.true.
	lims=.true.
	back=' '
	spchk=.false.
	go to 100
c
	entry at_sreal(prompt,val,setr,chkr,id)
	needb=.false.
	lims=.false.
	spchk=.true.
c
 100	continue
	istrin=' '
	if(spchk) then
	  call setr(istrin,val,id)
	endif
	if(istrin.eq.' ') then
	call jc__creal(val,istrin)	!convert real to short string
	endif
	ios=1
	do while(ios.ne.0)
	  string=istrin
	  if(needb) then
	    call at_bchar(prompt,string,back)
	    if(back.ne.' ') return
	  else
	    call at_char(prompt,string)
	  endif
	  if(spchk) then
	    call chkr(string,y,id)
	  endif
	  if(ios.ne.0) then
	    read(string,'(bn,e20.0)',iostat=ios) y
	    if(ios.ne.0) then
	      call at__error(string,'Real')
	    elseif(lims) then
	      if(y.lt.rlo .or. y.gt.rhi) then
		type *,'Sorry, real out of range',rlo,rhi
		ios=-1
	      endif
	    endif
	  endif
	enddo
	val=y
	end
	subroutine at_dbl(prompt,dval)		!doubl precision!11/09/84
	character prompt*(*),string*30,back*(*)
	character istrin*30
	real*8 dval,y,dlo,dhi
	logical needb,lims
	needb=.false.
	lims=.false.
	go to 100
c
	entry at_bdbl(prompt,dval,back)
	needb=.true.
	lims=.false.
	back=' '
	go to 100
c
	entry at_ldbl(prompt,dval,dlo,dhi)
	needb=.false.
	lims=.true.
 100	continue
	ios=1
	write(istrin,'(D)') dval
	do while(ios.ne.0)
	  string=istrin
	  if(needb) then
	    call at_bchar(prompt,string,back)
	    if(back.ne.' ') return
	  else
	    call at_char(prompt,string)
	  endif
	  read(string,'(bn,d30.0)',iostat=ios) y
	  if(ios.ne.0) then
	    call at__error(string,'Double Precision')
	    elseif(lims) then
	      if(y.lt.dlo .or. y.gt.dhi) then
		type *,'Sorry, real*8 out of range',dlo,dhi
		ios=-1
	      endif
	    endif
	enddo
	dval=y
	end
	subroutine at_log(prompt,val)		!logical value 	!02/13/85
	character prompt*(*),string*1,back*(*)
	character istrin*1
	logical val,needb
	needb=.false.
	go to 100
c
	entry at_blog(prompt,val,back)
	needb=.true.
	back=' '
 100	continue
	ios=1
	istrin='N'
	if(val) istrin='Y'
	do while(ios.ne.0)
	  string=istrin
	  if(needb) then
	    call at_bchar(prompt,string,back)
	    if(back.ne.' ') return
	  else
	    call at_char(prompt,string)
	  endif
	  if(index('TY1FN0',string).ne.0) then
	val=.false.
	    if(index('TY1',string).ne.0) val=.true.
	    ios=0
	  else
	    call at__error(string,'Logical')
	  endif
	enddo
	end
	subroutine at_bchar(prompt,ans,back)	!string		!11/09/84
	character*(*) prompt,ans,back	!Given the prompt, input the answer
	back=' '
	call at_char(prompt,ans)
	if(ans(1:1).eq.'/') then
	  ans='0'
	  back='B'
	endif
	end
	subroutine at_lchar(prompt,ans,clist,nlist) !legal string	!11/09/84
	character*(*) prompt,ans,clist(nlist),back
	character string*72
	logical nomatch,needb
	needb=.false.
	go to 100
c
	entry at_blchar(prompt,ans,clist,nlist,back)
	needb=.true.
	back=' '
100	continue
	nomatch=.true.
	do while(nomatch)
	  string=ans	!copy ans to temporary
	  if(needb) then
	    call at_bchar(prompt,string,back)	!string
	    if(back.ne.' ') return
	  else
	    call at_char(prompt,string)		!string
	  endif
	  i=0
	  do while(i.lt.nlist .and. nomatch)
	    i=i+1
	    nc=jc_trim(clist(i))
	    if(index(clist(i),'*').ne.0) then
	      nomatch=.false.
	      j=0
	      do while (j.lt.nc .and. .not.nomatch)
		j=j+1
		if(string(j:j).ne.clist(i)(j:j) .and. clist(i)(j:j).ne.'*')
     >		  nomatch=.true.
	      enddo
	    else
	      nomatch=string(1:nc).ne.clist(i)(1:nc)
	    endif
	  enddo
	  if(nomatch) then
	    type *,'Sorry, the only legal input strings are:'
	    type *,(clist(i),' ',i=1,nlist)
	  else
	    ans=string
	  endif
	enddo
	end
	subroutine at_error(ierr,string) !user called error msg	!06/20/88
	character string*(*),istrin*12
	call jc__cint(ierr,istrin)
	nc=jc_trim(string)
	call at_msg(string(1:nc)//': '//istrin)
	end
	subroutine at_msgi(string,ival) !text followed by intgr	!01/08/90
	character string*(*),istrin*12
	call jc__cint(ival,istrin)
	nc=jc_trim(string)
	call at_msg(string(1:nc)//' '//istrin)
	end
	subroutine at_msg(string)	!output text string	!02/08/85
	character*(*) string
	type *,string(1:jc_trim(string))
	end
	subroutine at_rlimits(prompt,rlo,rhi)			!03/26/85
	character*(*) prompt
	call at_real(prompt//', low limit',rlo)
	call at_real(prompt//', high limit',rhi)
	end
	subroutine at_ucmmd(opt,ierr)
	character opt*(*),op*1
	op=opt(2:2)
	if(op.eq.'N') op=opt(3:3)
	if(index('CE',op).gt.0) then	!allow /E,/NE,/C,/NC
	  call at_switch(opt,opt)
	endif
cx	/T  = always output prompt (for batch jobs)
cx	/NT = no typeahead prompt
	end
	subroutine user_end		!dummy user end
	call exit(0)
	end
