c  sgnco.for	new contour routines derived from ncar library
c
c  oct-89	created module from conrec,clgen,stline,drline
c
c  feb-93	fix calculation of dashed vs solid lines in agculev.
c		modify agcxget/agcyget for non-VMS compilsers. [met]
c
c----------------------------------------------------------------/agclini
c
	subroutine agclini(liru,lplu,lamu)
c
	integer iklrs(*),isyms(*),idshs(*)
c
	include 'sgnco_inc'
	external ufxy
c
	kfill=0
	nsym=0		!no symbols
	ndsh=0		!no dashes
	do i=1,nlm
	  kmap(i)=1	!init all colors to black
	  kdsh(i)=0	!all solid lines
	  ksym(i)=0	!no symbols
	enddo
	jufxy=0
c
	nir=max(0,liru)
	npl=max(0,lplu)
	lam=80000
	if(lamu.gt.0) lam=lamu
	return
c
	entry agcolrs(nklr,iklrs,ifill)
c
c  nklr=0  to turn off color lines and color fill
c       > 0  is number of entries in the color sequence
c  iklrs      contains the sequence of color codes
c  ifill > 0 to turn on color fill
c
	if(nklr.gt.0) then
	  kmap(1)=0	!base color is white
	  do i=2,nlm
	    j=mod(i-2,nklr)+1
	    kmap(i)=iklrs(j)
	  enddo
	endif
	kfill=ifill
	return
c
	entry agcsymb(nums,isyms,istep)
c
c  isymb	is symbol code
c  istep	is step between symbols
c
	nsym=nums
	if(nums.gt.0) then
	  do i=1,nlm
	    j=mod(i-1,nums)+1
	    ksym(i)=isyms(j)
	  enddo
	  call agsteps(istep,istep/2)
	endif
	return
c
	entry agcdash(numd,idshs)
c
c  idshs	is array of dash codes
c
	if(numd.gt.0) then
	  do i=1,nlm
	    j=mod(i-1,numd)+1
	    kdsh(i)=idshs(j)
	  enddo
	endif
	return
c
	entry agctran(ufxy)
c
	jufxy=%loc(ufxy)	!user transform for x,y
	return
	end
c%
c----------------------------------------------------------------/agclins
c
	subroutine agclins(zdata,mxd,x,nx,y,ny,cl,ncl)
c
	real zdata(mxd,*),x(*),y(*)
c
cdec$	psect  /conrer/ noshr
	common /conrer/ ince
	include 'sgnco_inc'
	integer ir(*)
	pointer (iir,ir)
	real cl(nlm)	!,rwork(nlm)
	integer iai(nlm),iag(nlm)
	real xfram(5),yfram(5)
	integer lvir,lvpl
	save lvir,lvpl
	character ctemp*12
	logical igood,lib_get_vm
	external agncof
c
c arguments
c	mxd	first (x) dimension of zdata
c	nx	number of data values to be contoured in the x-direction
c	ny	number of data values to be contoured in the y-direction
c
	ince=0		!no error
	xdir=sign(1.,x(2)-x(1))
	jx=3
	do while (ince.eq.0 .and. jx.le.nx)
	  if(sign(1.,x(jx)-x(jx-1)).ne.xdir) then
	    call ageset('agclins: x vector not monotonic',5,1)
	    go to 800
	  endif
	  jx=jx+1
	enddo
	ydir=sign(1.,y(2)-y(1))
	jy=3
	do while (ince.eq.0 .and. jy.le.ny)
	  if(sign(1.,y(jy)-y(jy-1)).ne.ydir) then
	    call ageset('agclins: y vector not monotonic',5,1)
	    go to 800
	  endif
	  jy=jy+1
	enddo
c
	if(lvir.eq.0) then
	  call usr_trnlog(' ','SG_IR_BUFFER',ctemp,lc,igood)
	  read(ctemp,'(bn,i12)',iostat=ios) lvir
	  if(lvir.eq.0) lvir=-1		!no translation
	  call usr_trnlog(' ','SG_PL_BUFFER',ctemp,lc,igood)
	  read(ctemp,'(bn,i12)',iostat=ios) lvpl
	  if(lvpl.eq.0) lvpl=-1		!no translation
	endif
c
	if(nir.eq.0) then
c GWH: Double precision generalization:
c	  nir=max(nx,ny)*4
c	  nir=max(nir,nx*ny/16)
	  nir=max(nx,ny)*nbytes_real
	  nir=max(nir,nx*ny/nbytes_real/nbytes_real)
	  nir=max(nir,1024)
	  if(lvir.gt.0) nir=lvir
	endif
	igood=lib_get_vm(nir*nbytes_real,iir)
	if (.not.igood) then
	  call ageset('agclins: no virtual memory',6,1)
	  return	!?go to 800
	endif
c
c set x,y scaling
	xorg=x(1)
	xrang=1.
	if(nx.gt.1) xrang=xrang/float(nx-1)
	xscal=(x(nx)-x(1))
	nxs=nx
	lax=%loc(x)
	yorg=y(1)
	yrang=1.
	if(ny.gt.1) yrang=yrang/float(ny-1)
	yscal=(y(ny)-y(1))
	nys=ny
	lay=%loc(y)
	call xneat(0)
	call yneat(0)
	call dlimx(x(1),x(nx))
	call dlimy(y(1),y(ny))
c
	call agseet(i4105,kfac,ic,is)
	if (i4105.eq.0) kfill=0
	ipl1=0
	if(kfill.ne.0 .or. nsym.ne.0) then
	  if(npl.eq.0) then
	    npl=max(nx,ny)*nbytes_real
	    npl=max(npl,512)
	    if(lvpl.gt.0) npl=lvpl
	  endif
	  igood=lib_get_vm(npl*nbytes_real,ipl1)
	  igood=lib_get_vm(npl*nbytes_real,ipl2)
	  if (.not.igood) then
	    call ageset('agclins: no virtual memory',6,1)
	    go to 800
	  endif
	endif
	iam=0
	if (kfill.ne.0) then
	  igood=lib_get_vm(lam*nbytes_real,iam)
	  if (.not.igood) then
	    call ageset('agclins: no virtual memory',6,1)
	    go to 800
	  endif
c
c@v	  call arinam(%val(iam),lam)	!c@v
	  call arinam(am,lam)
	  call ageget(1,ince,0)
	  if(ince.gt.0) go to 800
	  xfram(1)=x(1)	!define frame counterclockwise
	  xfram(2)=x(1)
	  xfram(3)=x(nx)
	  xfram(4)=x(nx)
	  xfram(5)=xfram(1)
	  yfram(1)=y(1)
	  yfram(2)=y(ny)
	  yfram(3)=y(ny)
	  yfram(4)=y(1)
	  yfram(5)=yfram(1)
		!outside (left) is -1, inside (right) is area 0
c@v	  call aredam(%val(iam),xfram,yfram,5,1,-1,0)	!c@v
	  call aredam(am,xfram,yfram,5,1,-1,0)
	else
	endif
c
	ince=0		!no error
c
c find major and minor lines - removed
c
cx	nml=0
cx	if(ilag.ne.0) then
cx	  call reord(cl,ncl,rwork,nml,nulbll+1)
cx	endif
c
c process each level
c
cx	fpart=.5
	mir=0		!high water mark for ir
	mpl=0		!high water mark for pl
	do i=1,ncl
	  contr=cl(i)
	  if (i4105.ne.0) then
	    kolor=max(kmap(i),1)
	    call linclr(kolor)
	    call agccurv(kolor)
	  endif
	  call symbl(ksym(i))
	  call line(kdsh(i))
	  igr=i		!group
	  iar=0		!area
c
c draw all lines at this level
c
c@v	  call agcstln(zdata,mxd,nx,ny,contr,%val(iir))	!c@v
	  call agcstln(zdata,mxd,nx,ny,contr,ir)
	  if(ince.gt.0) go to 800
	enddo
c
c  find relative minimums and maximums and mark values - removed
c
cx	if(nhi.eq.0) then
cx	  call minmax(zdata,mxd,nx,ny,isizem,ash,ioffdt)
cx	elseif(nhi.gt.0) then
cx	  call minmax(zdata,mxd,nx,ny,isizem,-ash,ioffdt)
cx	endif
c
	if (kfill.ne.0) then
c@v	  call arpram(%val(iam),1,1,1)	!c@v
	  call arpram(am,1,1,1)
	  call ageget(1,ince,0)
	  if(ince.gt.0) go to 800
	  npu=0
c@v	  call arscam(%val(iam),%val(ipl1),%val(ipl2),npl,iai,iag,nlm,agncof)	!c@v
	  call arscam(am,pl1,pl2,npl,iai,iag,nlm,agncof)
	endif
	if (i4105.ne.0) then
	  call linclr(1)	!black
	endif
c
 800	continue
	call lib_free_vm(nir*nbytes_real,iir)
	if(ipl1.ne.0) then
	  call lib_free_vm(npl*nbytes_real,ipl1)
	  call lib_free_vm(npl*nbytes_real,ipl2)
	endif
	if(iam.ne.0) then
	  call lib_free_vm(lam*nbytes_real,iam)
	endif
	return
	end
c----------------------------------------------------------------/agclgen
c
	subroutine agclgen(z,mxd,nx,ny,cclo,chi,cinc,cl,ncl,icnst)
cx	save
	parameter (nlm=40)
	parameter (nla=16)
	real cl(nlm), z(mxd,ny)
c
c agclgen puts the values of the contour levels in cl.
c variable names match those in conrec, with the following additions.
c	flo	value of lowest contour level; if flo=fhi=0., a value
c		rounded up from the minimum zdata is generated
c	fhi	value of highest contour level
c	finc	>0 => increment between contour levels
c		=0 => "nice" value (between 10 and 30) generated
c		<0 => abs(finc)=number of levels
c         ncl     -number of contour levels put in cl.
c         icnst   -flag to tell conrec if a constant field was detected.
c                 .icnst=0 means non-constant field.
c                 .icnst non-zero means constant field.
c
c to produce non-uniform contour level spacing, replace the code in this
c routine with code to produce whatever spacing is desired.
c
	icnst=0
	clo=cclo
	glo=clo
	ha=chi
	fanc=cinc
	crat=nla
	if(ha.lt.glo) then
	  glo=ha
	  ha=clo
	elseif(ha.eq.glo) then
	  if (glo.ne.0.) then
	    cl(1)=glo
	    ncl=1
	    return
	  endif
	  glo=z(1,1)
	  ha=z(1,1)
	  do j=1,ny
	    do i=1,nx
	      glo=min(z(i,j),glo)
	      ha=max(z(i,j),ha)
	    enddo
	  enddo
	  if (glo.ge.ha) then
	    icnst=1
	    ncl=1
	    cclo=glo
	    return
	  endif
	endif
	if (fanc.lt.0) crat=max(1.,-fanc)
	if (fanc.le.0) then
	  fanc=(ha-glo)/crat
	  p=10.**(ifix(alog10(fanc)+5000.)-5000)
	  fanc=max(aint(fanc/p),1.)*p
	endif
c
	if (chi.eq.clo) then
	  glo=aint(glo/fanc)*fanc
	  ha=aint(ha/fanc)*fanc*(1.+sign(1.e-6,ha))
	endif
	do k=1,nlm
	  cc=glo+float(k-1)*fanc
	  if (cc.gt.ha) go to 118
	  kk=k
	  cl(k)=cc
	enddo
  118	ncl=kk
	cclo=cl(1)
	chi=cl(ncl)
	cinc=fanc
	return
	end
c----------------------------------------------------------------/agcstln
c
	subroutine agcstln(z,ll,mm,nn,conv,ir)
	real z(ll,nn)
	integer ir(*)
c
c this routine finds the beginnings of all contour lines at level conv.
c first the edges are searched for lines intersecting the edge (open
c lines) then the interior is searched for lines which do not intersect
c the edge (closed lines).  beginnings are stored in ir to prevent
c retracing of lines.  if ir is filled, an error is output.
c
cdec$	psect  /conrer/ noshr
	common /conrer/ ince
	include 'sgnco_inc'
	parameter (iybits=16)	!?12
	logical drawh
	ixypak(ixx,iyy)=ishft(ixx,iybits)+iyy	!ishift
c
	l=ll
	m=mm
	n=nn
	cv=conv
	kir=0
	iss=.true.	!lines intersect frame
	drawh=n.le.m	!draw horizontally if wider than higher
	inir=7
	if(drawh) inir=1
c
	do jp1=2,n		!bottom edge, left to right
 	  if (z(1,jp1).lt.cv .and. z(1,jp1-1).ge.cv) then
	    ix=1
	    iy=jp1-1
	    is=3
	    call agcdrln(z,l,m,n,ir)
	  endif
	  if(ince.gt.0) return
	enddo
	do ip1=2,m		!right edge, bottom to top
	  if (z(ip1,n).lt.cv .and. z(ip1-1,n).ge.cv) then
	    ix=ip1-1
	    iy=n
	    is=5
	    call agcdrln(z,l,m,n,ir)
	  endif
	  if(ince.gt.0) return
	enddo
	do jp1=n,2,-1		!top edge, right to left
	  if (z(m,jp1-1).lt.cv .and. z(m,jp1).ge.cv) then
	    ix=m
	    iy=jp1
	    is=7
	    call agcdrln(z,l,m,n,ir)
	  endif
	  if(ince.gt.0) return
	enddo
	do ip1=m,2,-1		!left edge, top to bottom
	  if (z(ip1-1,1).lt.cv .and. z(ip1,1).ge.cv) then
	    ix=ip1
	    iy=1
	    is=1
	    call agcdrln(z,l,m,n,ir)
	  endif
	  if(ince.gt.0) return
	enddo
	iss=.false.	!lines will close inside

	if(drawh) then
	do j=n-1,2,-1		!vertical
	  do ip1=m,2,-1		!horizontal
	  if (z(ip1-1,j).lt.cv .and. z(ip1,j).ge.cv) then
	    ixy=ixypak(ip1,j)
	    call agcirck(ir,kir,ixy,inn)
	    if(inn.gt.0) go to 107		!cycle
	    call agcirst(ir,kir,nir,ixy,ince)
	    if(ince.gt.0) return
	    mir=max(mir,kir)
	    ix=ip1
	    iy=j
	    is=1
	    call agcdrln(z,l,m,n,ir)
	    if(ince.gt.0) return
	  endif
 107	  enddo
	enddo

	else	!(.not.drawh)
	do i=m-1,2,-1		!horizontal
	  do jp1=n,2,-1		!vertical
	  if (z(i,jp1-1).lt.cv .and. z(i,jp1).ge.cv) then
	    ixy=ixypak(i,jp1)
	    call agcirck(ir,kir,ixy,inn)
	    if(inn.gt.0) go to 109		!cycle
	    call agcirst(ir,kir,nir,ixy,ince)
	    if(ince.gt.0) return
	    mir=max(mir,kir)
	    ix=i
	    iy=jp1
	    is=7
	    call agcdrln(z,l,m,n,ir)
	    if(ince.gt.0) return
	  endif
 109	  enddo
	enddo
	endif
	return
	end
c----------------------------------------------------------------/agcdrln
c
	subroutine agcdrln(z,l,mm,nn,ir)
	real z(l,nn)
	integer ir(*)
c
c this routine traces a contour line when given the beginning by agcstln.
c transformations can be added by deleting the statement functions for
c fx and fy in agcdrln and minmax and adding external functions.
c x=1. at z(1,j), x=float(m) at z(m,j). x takes on non-integer values.
c y=1. at z(i,1), y=float(n) at z(i,n). y takes on non-integer values.
c
cdec$	psect  /conrer/ noshr
	common /conrer/ ince
	include 'sgnco_inc'
	integer inx(8),iny(8)
	data inx /-1,-1,0,1,1,1,0,-1/
	data iny /0,1,1,1,0,-1,-1,-1/
	logical insect,closed
c
	parameter (iybits=16)	!?12
	ixypak(ixx,iyy)=ishft(ixx,iybits)+iyy	!ishift
	c(p1,p2)=(p1-cv)/(p1-p2)
c
	m=mm
	n=nn
	ix0=ix
	iy0=iy
	is0=is
	idx=inx(is)
	idy=iny(is)
	if (idx.ne.0) then
	  y=iy
	  x=c(z(ix,iy),z(ix+idx,iy))*float(idx)+float(ix)
	else
	  x=ix
	  y=c(z(ix,iy),z(ix,iy+idy))*float(idy)+float(iy)
	endif
	if(linx) then
	  fxx=xorg + (x-1.)*xrang*xscal
	else
c@v	  call agcxget(x,fxx,%val(lax),nxs)	!c@v
	  call agcxget(x,fxx,xarr,nxs)
	endif
	if(liny) then
	  fyy=yorg + (y-1.)*yrang*yscal
	else
c@v	  call agcyget(y,fyy,%val(lay),nys)	!c@v
	  call agcyget(y,fyy,yarr,nys)
	endif
	if(jufxy.ne.0) then
	  x=fxx
	  y=fyy
c@v	  call agcutrn(%val(jufxy),x,y,fxx,fyy)	!c@v
	  call agcutrn(uufxy,x,y,fxx,fyy)
	endif
	call agcfrst (fxx,fyy)
	closed=.false.
	insect=.false.
	do while (.not.closed .and. .not.insect)
	  is=is+1
	  if (is.gt.8) is=is-8
	  idx=inx(is)
	  idy=iny(is)
	  ix2=ix+idx
	  iy2=iy+idy
	  if (iss) then		!if frame
	    insect=ix2.gt.m .or. iy2.gt.n .or. ix2.lt.1 .or. iy2.lt.1
	    if (insect) go to 120	!leave
	  endif
	  if (cv.le.z(ix2,iy2)) then
	    is=is+4
	    ix=ix2
	    iy=iy2
	    go to 106	!cycle
	  endif
	  if (is/2*2.eq.is) go to 106	!cycle
	  if (idx.ne.0) then
	    y=iy
	    x=c(z(ix,iy),z(ix+idx,iy))*float(idx)+float(ix)
	  else
	    x=ix
	    y=c(z(ix,iy),z(ix,iy+idy))*float(idy)+float(iy)
	  endif
	  if(linx) then
	    fxx=xorg + (x-1.)*xrang*xscal
	  else
c@v	    call agcxget(x,fxx,%val(lax),nxs)	!c@v
	    call agcxget(x,fxx,xarr,nxs)
	  endif
	  if(liny) then
	    fyy=yorg + (y-1.)*yrang*yscal
	  else
c@v	    call agcyget(y,fyy,%val(lay),nys)	!c@v
	    call agcyget(y,fyy,yarr,nys)
	  endif
	  if(jufxy.ne.0) then
	    x=fxx
	    y=fyy
c@v	    call agcutrn(%val(jufxy),x,y,fxx,fyy)	!c@v
	  call agcutrn(uufxy,x,y,fxx,fyy)
	  endif
	  call agcvect (fxx,fyy)
	  if(ince.gt.0) return
	  if (is.eq.inir) then
	    call agcirst(ir,kir,nir,ixypak(ix,iy),ince)
	    if(ince.gt.0) return
	    mir=max(mir,kir)
	  endif
	  if (.not.iss) then
	    closed=ix.eq.ix0 .and. iy.eq.iy0 .and. is.eq.is0
cx	    if (closed) go to 120	!leave
	  endif
 106	enddo
c
c end of line
c
 120	continue
	iar=iar+1		!area number
	if (closed.or.insect) then
	  ilft=0
	  irgt=iar
	else
	  ilft=iar
	  irgt=0
	endif
	call agclast
	return
	end
c
c----------------------------------------------------------------/agcxget
	subroutine agcxget(xind,fxx,x,nxs)
	real x(*),y(*)
c
	ixx=xind		!1<=xind<=nxs
	ixn=ixx+1
	if(ixn.le.1) then
	  fxx=x(1)
	elseif(ixx.ge.nxs) then
	  fxx=x(nxs)
	else
	  fxx=x(ixx)+(xind-float(ixx))*(x(ixn)-x(ixx))
	endif
	return
c
	entry agcyget(yind,fyy,y,nys)
c
	iyy=yind		!1<=yind<=nys
	iyn=iyy+1
	if(iyn.le.1) then
	  fyy=y(1)
	elseif(iyy.ge.nys) then
	  fyy=y(nys)
	else
	  fyy=y(iyy)+(yind-float(iyy))*(y(iyn)-y(iyy))
	endif
	return
	end
c
c----------------------------------------------------------------/agcfrst
	subroutine agcfrst(x,y)
c
cdec$	psect  /conrer/ noshr
	common /conrer/ ince
	include 'sgnco_inc'
	integer ibasec /1/
c
	if (kfill.ne.0 .or. nsym.ne.0) then
	  kpl=0
	  !? store ix,iy instead of x,y
c@v	  call agcplst(%val(ipl1),%val(ipl2),kpl,x,y)	!c@v
	  kpl=kpl+1
	  pl1(kpl)=x
	  pl2(kpl)=y
	  mpl=max(mpl,kpl)
	else
	  line=comget(ibasec)
	  call movea(x,y)
	  kpl=0
	endif
	return
c----------------------------------------------------------------/agcvect
c
	entry agcvect(x,y)
	if(kpl.gt.0) then
	  if(kpl.ge.npl) then
	    call ageset('agcdrln: pl buffer overflow',4,1)
	    ince=4	!call ageget(1,ince,0)
	    return
	  endif
c@v	  call agcplst(%val(ipl1),%val(ipl2),kpl,x,y)	!c@v
	  kpl=kpl+1
	  pl1(kpl)=x
	  pl2(kpl)=y
	  mpl=max(mpl,kpl)
	else
	  if(line.le.0) then
	  call drawa(x,y)
	  else
	  call dasha(x,y,line)
	  endif
	endif
	return
c----------------------------------------------------------------/agclast
c
	entry agclast
	if(kpl.gt.0) then
	  call npts(kpl)
	  call cplot(%val(ipl1),%val(ipl2))
	  if(kfill.ne.0) then
c@v	  call aredam(%val(iam),%val(ipl1),%val(ipl2),kpl,igr,ilft,irgt)	!c@v
	  call aredam(am,pl1,pl2,kpl,igr,ilft,irgt)
	  call ageget(1,ince,0)
	  endif
	endif
	return
	end
c
	subroutine agcirst(ir,kir,nir,ixy,ince)
	integer ir(*)
	character cnir*12
	if (kir.ge.nir) then
	  write(cnir,'(i12)',iostat=ios) nir
	  call ageset('agclins: ir buffer overflow'//cnir,2,1)
	  ince=2
	  return
	endif
	kir=kir+1
	ir(kir)=ixy
	return
c
	entry agcirck(ir,kir,ixy,in)
	do i=1,kir
	  if(ir(i).eq.ixy) then
	    in=1
	    return
	  endif
	enddo
	in=0
	return
	end
c
	subroutine agcplst(pl1,pl2,kpl,x,y)
	real pl1(*),pl2(*)
	kpl=kpl+1
	pl1(kpl)=x
	pl2(kpl)=y
	end
c
	subroutine agncof(xcs,ycs,ncs,iai,iag,nai)
	real xcs(*),ycs(*)
	integer iai(*),iag(*)
	include 'sgnco_inc'
c
	itop=0
	do i=1,nai
	  if(iai(i).gt.0) itop=max(itop,iag(i))
	enddo
	if(itop.eq.0) return
	kolor=kmap(itop)
	if(kolor.eq.0) return
	if(npu.eq.0) call seetw(minx,maxx,miny,maxy)
	ixt=nint(xcs(1)*float(maxx-minx)+float(minx))
	iyt=nint(ycs(1)*float(maxy-miny)+float(miny))
	call agpnclr(-kolor)
	call begpnl(ixt,iyt,0)
	do i=2,ncs
	  ixt=nint(xcs(i)*float(maxx-minx)+float(minx))
	  iyt=nint(ycs(i)*float(maxy-miny)+float(miny))
	  call movabs(ixt,iyt)
	enddo
	call endpnl
	npu=max(npu,ncs)
	return
	end
c%
	subroutine agcutrn(ufxy,x,y,fxx,fyy)
	external ufxy
	call ufxy(x,y,fxx,fyy)
	end
c%
c----------------------------------------------------------------/rcontr
	subroutine rcontr(k1,c,k2,a,maxa,xarray,imin,imax,istep,
     >	  yarray,jmin,jmax,jstep)
	real a(maxa,*),c(*),xarray(*),yarray(*)
c	parameter (nbytes_real = 4) ! Single Precision
	parameter (nbytes_real = 8) ! Double Precision
	parameter (nlm=40)
	real cl(nlm)
	real xar(*),yar(*),zar(*)
	pointer (lxar,xar), (lyar,yar), (lzar,zar)
	logical igood,lib_get_vm
c  assumes that a(i,j)=fcn(xarray(i),yarray(j))
	nx=(imax-imin+istep)/istep
	ny=(jmax-jmin+jstep)/jstep
	nxy=nx*ny
	igood=lib_get_vm(nxy*nbytes_real,lzar)
	igood=lib_get_vm(nx*nbytes_real,lxar)
	igood=lib_get_vm(ny*nbytes_real,lyar)
c@v	jax=lxar	!c@v
	ii=0
	do i=imin,imax,istep
c@v	  call iag$movl(xarray(i),%val(jax),1)	!c@v
c@v	  jax=jax+4			!c@v
	  ii=ii+1
	  xar(ii)=xarray(i)
	enddo
c@v	jay=lyar	!c@v
	jj=0
	do j=jmin,jmax,jstep
c@v	  call iag$movl(yarray(j),%val(jay),1)	!c@v
c@v	  jay=jay+4			!c@v
	  jj=jj+1
	  yar(jj)=yarray(j)
	enddo
c@v	jaz=lzar	!c@v
	ii=0
	do j=jmin,jmax,jstep
	  do i=imin,imax,istep
c@v	    call iag$movl(a(i,j),%val(jaz),1)	!c@v
c@v	    jaz=jaz+4			!c@v
	    ii=ii+1
	    zar(ii)=a(i,j)
	  enddo
	enddo
c
	call agclini(0,0,0)
c@v	call agculev(k1,c,k2,%val(lzar),nxy,cl,ncl)	!c@v
	call agculev(k1,c,k2,zar,nxy,cl,ncl)
c@v	call agclins(%val(lzar),nx,%val(lxar),nx,%val(lyar),ny,cl,ncl)	!c@v
	call agclins(zar,nx,xar,nx,yar,ny,cl,ncl)
c
	call lib_free_vm(nxy*nbytes_real,lzar)
	call lib_free_vm(ny*nbytes_real,lyar)
	call lib_free_vm(nx*nbytes_real,lxar)
	end
c%
c----------------------------------------------------------------/contur
	subroutine contur(k1,c,k2,a,maxa,xarray,imin,imax,istep,
     >	  yarray,jmin,jmax,jstep)
	real a(maxa,*),c(*),xarray(maxa,*),yarray(maxa,*)
c       parameter (nbytes_real = 4)     ! Single Precision
        parameter (nbytes_real = 8)     ! Double Precision
	parameter (nlm=40)
	real cl(nlm)
	real xar(*),yar(*),zar(*)
	pointer (lxar,xar), (lyar,yar), (lzar,zar)
	logical igood,lib_get_vm
	external agcuxy
c  assumes that a(i,j)=fcn(xarray(i,j),yarray(i,j))
	nx=(imax-imin+istep)/istep
	ny=(jmax-jmin+jstep)/jstep
	nxy=nx*ny
	igood=lib_get_vm(nxy*nbytes_real,lzar)
	igood=lib_get_vm(nx*nbytes_real,lxar)
	igood=lib_get_vm(ny*nbytes_real,lyar)
c@v	call agclxy(%val(lxar),nx,imin)	!c@v
c@v	call agclxy(%val(lyar),ny,jmin)	!c@v
	call agclxy(xar,nx,imin)
	call agclxy(yar,ny,jmin)
c@v	jaz=lzar	!c@v
	ii=0
	do j=jmin,jmax,jstep
	  do i=imin,imax,istep
c@v	    call iag$movl(a(i,j),%val(jaz),1)	!c@v
c@v	    jaz=jaz+4			!c@v
	    ii=ii+1
	    zar(ii)=a(i,j)
	  enddo
	enddo
	call agcuset(xarray,yarray,maxa,nx,ny)
c
	call agclini(0,0,0)
c@v	call agculev(k1,c,k2,%val(lzar),nxy,cl,ncl)	!c@v
	call agculev(k1,c,k2,zar,nxy,cl,ncl)
	call agctran(agcuxy)
cx	call agcutrn(agcuxy,0,0,xx,yy)
c@v	call agclins(%val(lzar),nx,%val(lxar),nx,%val(lyar),ny,cl,ncl)	!c@v
	call agclins(zar,nx,xar,nx,yar,ny,cl,ncl)
c
	call lib_free_vm(nxy*nbytes_real,lzar)
	call lib_free_vm(nx*nbytes_real,lxar)
	call lib_free_vm(ny*nbytes_real,lyar)
	return
	end
c%
	subroutine agclxy(xar,nx,imin)
	real xar(*)
	do i=1,nx
	  xar(i)=i+imin-1	!?*istep
	enddo
	end
c%
	subroutine agcuset(xarray,yarray,maxa,nx,ny)
	real xarray(maxa,*),yarray(maxa,*)
	real arrx(*),arry(*)
	pointer (xara,arrx),(yara,arry)
	save nxx,nyy,maxaa,xara,yara
	nxx=nx
	nyy=ny
	maxaa=maxa
c@v	ixarr=%loc(xarray)	!c@v
c@v	iyarr=%loc(yarray)	!c@v
	xara=%loc(xarray)
	yara=%loc(yarray)
	return
c
	entry agcuxy(xraw,yraw,xdat,ydat)
c@v	call agcuxyi(%val(ixarr),%val(iyarr),maxaa,nxx,nyy,	!c@v
c@v     >	  xraw,yraw,xdat,ydat)	!c@v
	call agcuxyi(arrx,arry,maxaa,nxx,nyy,xraw,yraw,xdat,ydat)
	return
	end
c%
	subroutine agcuxyi(xarray,yarray,maxa,nx,ny,xraw,yraw,xdat,ydat)
	real xarray(maxa,nx),yarray(maxa,ny)
	ix=max(int(xraw),1)
	iy=max(int(yraw),1)
	ixn=min(ix+1,nx)
	iyn=min(iy+1,ny)
	xfrac=xraw-float(ix)
	yfrac=yraw-float(iy)
	xdat1=xarray(ix,iy)*(1.-xfrac)+xarray(ixn,iy)*(xfrac)
	xdat2=xarray(ix,iyn)*(1.-xfrac)+xarray(ixn,iyn)*(xfrac)
	xdat=xdat1*(1.-yfrac)+xdat2*yfrac
	ydat1=yarray(ix,iy)*(1.-yfrac)+yarray(ix,iyn)*(yfrac)
	ydat2=yarray(ixn,iy)*(1.-yfrac)+yarray(ixn,iyn)*(yfrac)
	ydat=ydat1*(1.-xfrac)+ydat2*xfrac
	end
c%
	subroutine agculev(k1,c,k2,zar,nz,cl,ncl)
	real c(*),zar(*),cl(*)
	parameter (nlm=40)
	integer idash(nlm)
	if(k1.eq.0) then	!user specified levels
	  call agmnmx(zar,cmin,cmax,nz,1)
	  ncl=0
	  nsolid=nint((cmax-c(1))/c(2))
	  nsolid=min(nsolid,nlm-1)
	  ndashd=nint((c(1)-cmin)/c(2))
	  ndashd=min(ndashd,nlm-1-nsolid)
	  do i=ndashd,1,-1
	    ncl=ncl+1
	    cl(ncl)=c(1)-(i)*c(2)
	    idash(ncl)=1
	  enddo
	  do i=0,nsolid
	    ncl=ncl+1
	    cl(ncl)=c(1)+(i)*c(2)
	    idash(ncl)=0
	  enddo
	  call agcdash(ncl,idash)
	elseif(k1.gt.0) then
	  ncl=min(k1,nlm)
	  do i=1,ncl
	    cl(i)=c(i)
	  enddo
	  if(k2.gt.0) then
	    do i=1,k2-1
	      idash(i)=1
	    enddo
	    do i=k2,ncl
	      idash(i)=0
	    enddo
	    call agcdash(ncl,idash)
	  endif
	else		!k1.lt.0
	  ncl=min(-k1,40)
	  dff=(c(2)-c(1))/(ncl-1)
	  do i=1,ncl
	    cl(i)=c(1)+(i-1)*dff
	  enddo
cx	  cl(ncl)=c(2)
	  do i=2,ncl
	    c(i)=cl(i)
	  enddo
	endif
	end
c%
c@v	subroutine iag$movl(ifrom,ito,nwrd)	!c@v
c@v	integer ifrom(*),ito(*)	!c@v
c@v	do i=1,nwrd	!c@v
c@v	  ito(i)=ifrom(i)	!c@v
c@v	enddo	!c@v
c@v	end	!c@v
c%
c----------------------------------------------------------------/agraph
c  draw graph and map virtual space for contour plot
c
	subroutine agraph(minx,maxx,miny,maxy,xmin,xmax,ymin,ymax,
     >	  xlabl,ylabl)
	character xlabl*(*), ylabl*(*)
	real x(2), y(2)
c
	call binitt
	call xfrm(2)		!short ticks
	call yfrm(2)
cx	call xneat(0)		!frame data exactly
cx	call yneat(0)
	call slimx(minx,maxx)	!screen limits
	call slimy(miny,maxy)
	call dlimx(xmin,xmax)	!data limits
	call dlimy(ymin,ymax)
	call npts(0)
	call check(x,y)
	call agdspl(x,y)	!draw left/bottom axes, label ticks
	call xloctp(0)		!setup for top/right axes
	call ylocrt(0)
	call grid		!put ticks on top/right, no tick labels
	call xloc(0)		!back to bottom/left for agt routines
	call yloc(0)
	call agtchs(xlabl,0)	!put user labels
	call agtcvs(ylabl,0)
	return
	end
c%
c----------------------------------------------------------------/agrcfr
c  draw grid with ticks which just encloses a contour plot
c
	subroutine agrcfr(x,imin,imax,istep,y,jmin,jmax,jstep,igrid)
	real x(*),y(*)
	real xx(2),yy(2)
	call xfrm(2)		!short ticks, outside
	call yfrm(2)
	call xneat(0)		!frame data exactly
	call yneat(0)
	call npts(2)
	xx(1)=x(imin)		!first x value
	irem=mod((imax-imin),istep)
	xx(2)=x(imax-irem)
	yy(1)=y(jmin)
	irem=mod((jmax-jmin),jstep)
	yy(2)=y(jmax-irem)
	call check(xx,yy)
	call agdspl(xx,yy)	!draw grid&ticks, label ticks
	if(igrid.eq.2) then
	  call xloctp(0)	!set up for top/right grid
	  call ylocrt(0)
	  call grid		!draw grid&ticks, no tick labels
	  call xloc(0)		!back to bottom/left for agt routines
	  call yloc(0)
	else
	  call frame		!just draw box
	endif
	return
	end
c----------------------------------------------------------------/agcfram
c  draw grid with ticks which just encloses a contour plot
	subroutine agcfram(x,nx,y,ny,igrid)
	real x(*),y(*)
	real xx(2),yy(2)
	call xfrm(2)		!short ticks, outside
	call yfrm(2)
	call xneat(0)		!frame data exactly
	call yneat(0)
	call npts(2)
	xx(1)=x(1)		!first x value
	xx(2)=x(nx)
	yy(1)=y(1)
	yy(2)=y(ny)
	call check(xx,yy)
	call agdspl(xx,yy)	!draw grid, ticks, labels
	if(igrid.eq.2) then
	  call xloctp(0)	!set up for right/top grid
	  call ylocrt(0)
	  call grid		!draw grid/ticks (no tick labels)
	  call xloc(0)		!back to bottom/left for agt routines
	  call yloc(0)
	else
	  call frame		!just draw box
	endif
	return
	end
