/* sglib system level i/o functions
*/

#include <stdio.h>
#include <ctype.h>
#include <strings.h>

#ifdef sgi
#define SYS5
#endif

#ifdef sun
#define SYS5
#endif

#ifdef __osf__
#define SYS5
#endif

#include <fcntl.h>
#ifdef SYS5
#include <sys/termio.h>
#endif
#ifndef SYS5	/* POSIX */
#include <sys/termios.h>
#endif
#include <sys/socket.h>
#include <sys/un.h>
#include <errno.h>
#include "sgbuff.h"
#define MAXCHAR 128
#define FALSE 0
#define TRUE 1
#define rw__r__r_ 0722

char dskfil[MAXCHAR];
char ttyfil[MAXCHAR];
char mbxfil[MAXCHAR];
int dsk_nr, tmp_nr, tty_nr, inp_nr;

#ifdef sun
/* GWH:  strerror is an ansi standard routine, but I can't find it on the
SUN's, not even in the GNU libgcc.a.  Here is a hack substitute:
*/
char strtmp[32];
char *strerror(int errno)
{
  sprintf(strtmp, "Error in sgsys: %d", errno);
  return(strtmp);
}
#endif


usr_trnlog_(char *table, char *loglnam, char *physnam, int *ltran,
 int *igood, int ltabl, int llog, int lphys)
{
  char *variable, loc_nam[MAXCHAR], *getenv();
  /* convert to null delimited string */
  to_C_nam(loc_nam, loglnam, llog);
  /* lookup environmental variables */
  if((variable = getenv(loc_nam)) == NULL) {
    *igood = FALSE;
    to_FORT_nam(physnam, lphys, " ");
    *ltran = 0;
  } else {
    *igood = TRUE;
    if(strcmp(loc_nam,"TERMINAL_TYPE")==0)
      to_up_str(variable); /* SGLIB wants upper case terminal type */
    /* convert to FORTRAN character string */
    to_FORT_nam(physnam, lphys, variable);
    *ltran = strlen(variable);
  }
}

to_up_str(char *str)
{
  for( ; *str != '\0'; str++){
    if(islower(*str)) *str = toupper(*str);
  }
  return;
}

to_C_nam(char *c_str, char *f_str, int flen)
{
  /* convert from FORTRAN character variable to NULL delimited string */
  int i;
  for(i = 0; i < flen && f_str[i] != '\0'; i++) c_str[i] = f_str[i];
  for(i--; i > 0 && c_str[i] == ' '; i--);
  c_str[++i] = '\0';
  if(i == flen) return(FALSE);
  return(TRUE);
}

to_FORT_nam(char *f_str, int flen, char *c_str)
{
  /* convert from NULL delimited character string to FORTRAN character
     variable */
  int i,j;
  for(i = 0; c_str[i] != '\0' && i < flen; i++) f_str[i] = c_str[i];
  for(j = i; j < flen; j++) f_str[j] = ' ';
  if(i == flen) return(FALSE);
  return(TRUE);
}

usr_getdvi_(char *devnam, int *klass, int *igood, int ldevn)
{
  char loc_nam[MAXCHAR];
  to_C_nam(loc_nam, devnam, ldevn);
  if(strchr(loc_nam,'.')) {
    *klass = 1;  /* disk file */
  } else {
    *klass = 2;  /* terminal */
  }
  *igood = 1;  /* errno */
  return;
}

usr_putmsg_(int *igood)
{
  printf("Fatal error in SGLIB %i\n", igood);
  return;
}
usr_dclexh_()
{
  /* signal(SIGINT, &handler) */
}


tkeep_disk_()
{
int tsize, ntmp;
char *tcopy;
  if(tmp_nr==0) return;
  /* size of file = current position */
  tsize = lseek(tmp_nr, 0L, 1);
  /* rewind temp file */
  lseek(tmp_nr, 0L, 0);
  /* copy from temp file to disk file */
  tcopy = (char *) malloc(tsize);
  if(tcopy==0) {
    printf("Can't copy page to disk file\n");
  } else {
    ntmp = read(tmp_nr, tcopy, tsize);
    if(ntmp<0) printf("%s\n", strerror(errno));
    ntmp = write(dsk_nr, tcopy, tsize);
    if(ntmp<0) printf("%s\n", strerror(errno));
    free(tcopy);
  }
  /* rewind temp file */
  lseek(tmp_nr, 0L, 0);
}

tback_disk_()
{
  if(tmp_nr==0) return;
  /* rewind temp file */
  lseek(tmp_nr, 0L, 0);
  sg_buff_.kdptr = 0;
}

tmark_disk_()
{
}


tsend_()
{
  /* empty io buffer to output device(s) */
  if(sg_flag_.outdsk>0) tsend_disk_();
  if(sg_flag_.outtrm>0 || sg_flag_.outaux>0) tsend_term_();
  return;
}


tname_term_(char *ttynam, int ltty)
{
  to_C_nam(ttyfil, ttynam, ltty);  /* ttyfil = ttynam */
  return;
}

topen_term_()
{
  if(strcmp(ttyfil,"stdout")==0) {
    tty_nr = 1;
  } else {
    tty_nr = open(ttyfil, O_WRONLY, 0);
    if(tty_nr<0) printf("%s\n", strerror(errno));
  }
  sg_buff_.tbufa = (char *) malloc(sg_buff_.maxtb);
  sg_flag_.outtrm = 1;
  return;
}
static int sd_mbx;	/* xtc output socket descriptor */
static int sd_gin;	/* xtc input socket descriptor */

topen_auxl_()
{
  struct sockaddr_un socket_mbx;
  struct sockaddr_un socket_gin;
  /* Fill in socket names.  Full path names for sockets are
  ** /tmp/xtc_mbx_#_username and /tmp/xtc_gin_#_username.  */
  sprintf( socket_mbx.sun_path, "/tmp/%s\0", mbxfil);
  sprintf( socket_gin.sun_path, "/tmp/%s\0", mbxfil);
  strncpy( &socket_gin.sun_path[9], "gin", 3);
  socket_mbx.sun_family = AF_UNIX;
  socket_gin.sun_family = AF_UNIX;

  sd_mbx = socket(AF_UNIX, SOCK_STREAM, 0);
  if(sd_mbx<0) printf("%s\n", strerror(errno));
  sd_gin = socket(AF_UNIX, SOCK_STREAM, 0);
  if(sd_gin<0) printf("%s\n", strerror(errno));

  if (connect(sd_mbx, &socket_mbx, sizeof(socket_mbx)) == -1)
    printf("%s\n", strerror(errno));
  if (connect(sd_gin, &socket_gin, sizeof(socket_gin)) == -1)
    printf("%s\n", strerror(errno));
  sg_buff_.tbufa = (char *) malloc(sg_buff_.maxtb);
  sg_flag_.outaux = 1;
  return;
}


tsend_term_()
{
  int np, n_written;
  /* empty io buffer to tty */
  if((np = sg_buff_.ktptr)==0) return;
  if(sg_flag_.outtrm==1) {
    if((n_written = write(tty_nr, sg_buff_.tbufa, np)) != np) {
      printf("SGLIB WRITE ERROR: n_written = %d, np = %d\n",
  	   n_written, np);
      exit(1);
    }
  }
  if(sg_flag_.outaux==1) {
    if((n_written = send(sd_mbx, sg_buff_.tbufa, np, 0)) != np) {
      printf("SGLIB SEND ERROR: n_written = %d, np = %d\n",
  	   n_written, np);
      exit(1);
    }
  }
  sg_buff_.ktptr = 0;
  return;
}

tback_term_()
{
  /* clear the terminal buffer */
   return;
}

tname_auxl_(char *mbxnam, int lmbx)
{
  to_C_nam(mbxfil, mbxnam, lmbx);  /* mbxfil = mbxnam */
  return;
}

tname_disk_(char *dsknam, int ldsk)
{
  to_C_nam(dskfil, dsknam, ldsk);  /* dskfil = dsknam */
  return;
}

topen_disk_()
{
  FILE *tfile;
  dsk_nr = creat(dskfil, rw__r__r_);
  if(dsk_nr<0) printf("%s\n", strerror(errno));
  tmp_nr = 0;
  /* if output to file and tty, open temp file for each page */
  if(sg_flag_.outtrm != 0) {
    tfile = tmpfile();
    tmp_nr = fileno(tfile);
    if(tmp_nr<0) printf("%s\n", strerror(errno));
  }
  sg_buff_.dbufa = (char *) malloc(sg_buff_.maxdb);
  sg_flag_.outdsk = 1;
  return;
}

tsend_disk_()
{
  int np, n_written;
  /* empty io buffer to disk */
  if((np = sg_buff_.kdptr)==0) return;
  if(tmp_nr>0) {
    n_written = write(tmp_nr, sg_buff_.dbufa, np);
  } else {
    n_written = write(dsk_nr, sg_buff_.dbufa, np);
  }
  /* lseek(dsk_nr, 0L, 2);  /* set to end of file */
  if(n_written != np) {
    printf("SGLIB WRITE ERROR: n_written = %d, np = %d\n",
	   n_written, np);
    exit(1);
  }
  sg_buff_.kdptr = 0;
  return;
}

tview_disk_()
{
  dsk_nr = open(dskfil, rw__r__r_);
  if(dsk_nr<0) printf("%s\n", strerror(errno));
  return;
}

tread_disk_(char *fbuf, int mfbuf, int inblk, int *ngot)
{
  int pos,n_read;
  pos = lseek(dsk_nr, 0L, 1);
  pos = lseek(dsk_nr, (inblk-1)*512, 0);
  n_read = read(dsk_nr, fbuf, mfbuf);
  *ngot = n_read;
  return;
}


void tclos_disk_()
{
  close(dsk_nr);
  dsk_nr = 0;
  return;
}

void tclos_term_()
{
  /* close terminal file ? */
  return;
}


void tinput_(int *inchh)
{
  char trmnam[64];
  int lnam,igood;
  int nin;

  tsend_term_();
  if(sg_flag_.inflg==0) {
    usr_trnlog_(" ","TERMINAL_INPUT",trmnam,&lnam,&igood,
	1,14,64);	/* string lengths */
    trmnam[lnam]='\0';
    if(strcmp(trmnam,"NONE")==0) {
      sg_flag_.inflg = 3;	/* no input */
      goto tin200;
    }
    if(sd_gin>0) {
      sg_flag_.inflg = 2;	/* XTC */
      goto tin200;
      }
    inp_nr = open("/dev/tty", O_RDONLY, 0);
    if(inp_nr>0)
      sg_flag_.inflg = 1;	/* tty input */
    else
      sg_flag_.inflg = 3;	/* error */
  }
tin200:
  if(sg_flag_.inflg==1) {
    /*  fflush(NULL); */
    /* get a single character */
    ocne(); /* set terminal to one character no echo mode */
    *inchh = getchar();
    canon(); /* reset to canonical mode */
  } else if(sg_flag_.inflg==2) {
    /* read from sd_gin */
    /* nin = recv(sg_gin,bufi,6,0); */
    nin = recv(sd_gin,inchh,1,0);
  }
  return;
}


#ifdef SYS5
struct termio init, new;
#endif
#ifndef SYS5
struct termios init, new;
#endif

ocne()
{
#ifdef SYS5
  ioctl(0, TCGETA, &init);
  ioctl(0, TCGETA, &new);
#endif
#ifndef SYS5
  ioctl(0, TCGETP, &init);
  ioctl(0, TCGETP, &new);
#endif
  new.c_lflag = new.c_lflag & ~(ECHO); /* turn off echo */
  new.c_lflag = new.c_lflag & ~(ICANON); /* turn off canonical */
  new.c_cc[VMIN] = 1; /* one character input */
  new.c_cc[VTIME] = 0;  /* timer off */
#ifdef SYS5
  ioctl(0, TCSETA, &new);
#endif
#ifndef SYS5
  ioctl(0, TCSANOW, &new);
#endif
}

canon()
{
#ifdef SYS5
  ioctl(0, TCSETA, &init);
#endif
#ifndef SYS5
  ioctl(0, TCSANOW, &init);
#endif
}

void iowait_()
{
}

void agtrap_()
{
}

void agtgbm_(char *msg, int *lmsg)
{
  *lmsg = 0;
}

void agtpurg_()
{
}

void ag_info_(int *mode, int *ipid, char *myterm, char *user, int lterm,
  int luser)
{
  *mode = 3;	/* interactive */
  *ipid = 0;
  to_FORT_nam(myterm, lterm, "stdout");
  to_FORT_nam(user, luser, "USER");
}

lib_get_vm_(int *nbytes, char **addr)
{
  *addr = (char *) malloc(*nbytes);
  return(TRUE);
}

lib_free_vm_(int nbytes, char **addr)
{
  free(*addr);
}
