/* entries for sg routines with variable length argument lists */
/* the length of a character string is passed by value at the end of
/*   the argument list
/* note: if((len = va_arg(alist, int))==0) to test for the existence of
/*   the last argument doesn't always work on the DECstation, so instead
/*   assume that a string is always less that 256 characters
*/

#include <varargs.h>
union strlen {
  int *nstr;
  int lstr;
  };
static int zero=0;

agtchs_(va_alist)
va_dcl
{
  va_list alist;
  char *str;
  union strlen alen;
  int len;

  va_start(alist);
  str = va_arg(alist, char*);
  alen.nstr = va_arg(alist, int*);
  if ((len = alen.lstr)<=256) { alen.nstr = &zero; /* short arg list */
  } else { len = va_arg(alist, int); }	/* long arg list */
  va_end(alist);
  agtchsl_(str, alen.nstr, len);
}

agtcgt_(va_alist)
va_dcl
{
  va_list alist;
  int *iy;
  char *str;
  union strlen alen;
  int len;

  va_start(alist);
  iy = va_arg(alist, int*);
  str = va_arg(alist, char*);
  alen.nstr = va_arg(alist, int*);
  if ((len = alen.lstr)<=256) { alen.nstr = &zero; /* short arg list */
  } else { len = va_arg(alist, int); }	/* long arg list */
  va_end(alist);
  agtcgtl_(iy, str, alen.nstr, len);
}

agtmhs_(va_alist)
va_dcl
{
  va_list alist;
  int *ix, *iy;
  char *str;
  union strlen alen;
  int len;

  va_start(alist);
  ix = va_arg(alist, int*);
  iy = va_arg(alist, int*);
  str = va_arg(alist, char*);
  alen.nstr = va_arg(alist, int*);
  if ((len = alen.lstr)<=256) { alen.nstr = &zero; /* short arg list */
  } else { len = va_arg(alist, int); }	/* long arg list */
  va_end(alist);
  agtmhsl_(ix,iy, str, alen.nstr, len);
}

agths_(va_alist)
va_dcl
{
  va_list alist;
  char *str;
  union strlen alen;
  int len;

  va_start(alist);
  str = va_arg(alist, char*);
  alen.nstr = va_arg(alist, int*);
  if ((len = alen.lstr)<=256) { alen.nstr = &zero; /* short arg list */
  } else { len = va_arg(alist, int); }	/* long arg list */
  va_end(alist);
  agthsl_(str, alen.nstr, len);
}

agtcvs_(va_alist)
va_dcl
{
  va_list alist;
  char *str;
  union strlen alen;
  int len;

  va_start(alist);
  str = va_arg(alist, char*);
  alen.nstr = va_arg(alist, int*);
  if ((len = alen.lstr)<=256) { alen.nstr = &zero; /* short arg list */
  } else { len = va_arg(alist, int); }	/* long arg list */
  va_end(alist);
  agtcvsl_(str, alen.nstr, len);
}

agtmvs_(va_alist)
va_dcl
{
  va_list alist;
  int *ix, *iy;
  char *str;
  union strlen alen;
  int len;

  va_start(alist);
  ix = va_arg(alist, int*);
  iy = va_arg(alist, int*);
  str = va_arg(alist, char*);
  alen.nstr = va_arg(alist, int*);
  if ((len = alen.lstr)<=256) { alen.nstr = &zero; /* short arg list */
  } else { len = va_arg(alist, int); }	/* long arg list */
  va_end(alist);
  agtmvsl_(ix,iy, str, alen.nstr, len);
}

agtvs_(va_alist)
va_dcl
{
  va_list alist;
  char *str;
  union strlen alen;
  int len;

  va_start(alist);
  str = va_arg(alist, char*);
  alen.nstr = va_arg(alist, int*);
  if ((len = alen.lstr)<=256) { alen.nstr = &zero; /* short arg list */
  } else { len = va_arg(alist, int); }	/* long arg list */
  va_end(alist);
  agtvsl_(str, alen.nstr, len);
}

agtmrs_(va_alist)
va_dcl
{
  va_list alist;
  int *ix, *iy, *irot;
  char *str;
  union strlen alen;
  int len;

  va_start(alist);
  ix = va_arg(alist, int*);
  iy = va_arg(alist, int*);
  irot = va_arg(alist, int*);
  str = va_arg(alist, char*);
  alen.nstr = va_arg(alist, int*);
  if ((len = alen.lstr)<=256) { alen.nstr = &zero; /* short arg list */
  } else { len = va_arg(alist, int); }	/* long arg list */
  va_end(alist);
  agtmrsl_(ix,iy, irot, str, alen.nstr, len);
}

agtrs_(va_alist)
va_dcl
{
  va_list alist;
  int *irot;
  char *str;
  union strlen alen;
  int len;

  va_start(alist);
  irot = va_arg(alist, int*);
  str = va_arg(alist, char*);
  alen.nstr = va_arg(alist, int*);
  if ((len = alen.lstr)<=256) { alen.nstr = &zero; /* short arg list */
  } else { len = va_arg(alist, int); }	/* long arg list */
  va_end(alist);
  agtrsl_(irot, str, alen.nstr, len);
}
